//
//  AppDelegate.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2022/12/2.
//

#import "AppDelegate.h"
#import "ViewController.h"
#import "ZegoRTCEngineManager.h"
#import "TLNavigationController.h"
#import <AVFoundation/AVFoundation.h>
#import "MQTabbarController.h"
#import "ZGAudioManager.h"
#if !DEBUG
//#import <Bugly/Bugly.h>
#endif

@interface AppDelegate ()
 
@end

 

@implementation AppDelegate

@synthesize window = _window;
UIBackgroundTaskIdentifier _bgTaskId;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    [ZegoRTCEngineManager.sharedInstance initRtc];
    
    MQTabbarController *tabbar = [[MQTabbarController alloc] init];
    tabbar.hidesBottomBarWhenPushed = YES;
    self.window = [[UIWindow alloc] init];
    self.window.frame = [UIScreen mainScreen].bounds;
    
    self.window.rootViewController = tabbar;
    [self.window makeKeyAndVisible];
    [self configBugly];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
  
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
//    [self comeToBackgroundMode];

    ZGAudioManager.sharedIntance.openBackgroundAudioAutoPlay = YES;
}

- (void)applicationWillEnterForeground:(UIApplication *)application {

}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    ZGAudioManager.sharedIntance.openBackgroundAudioAutoPlay = NO;
}

- (void)applicationWillTerminate:(UIApplication *)application {
    [ZegoRTCEngineManager.sharedInstance unInitRtc:^{

    }];
    [ZegoMiniGameEngine.sharedEngine unInit];
}


- (UIBackgroundTaskIdentifier)backgroundPlayerID:(UIBackgroundTaskIdentifier)backTaskId {
    //设置并激活音频会话类别
    AVAudioSession *session = [AVAudioSession sharedInstance];
    [session setCategory:AVAudioSessionCategoryPlayback error:nil];
    [session setActive:YES error:nil];
    //允许应用程序接收远程控制
    [[UIApplication sharedApplication] beginReceivingRemoteControlEvents];
    //设置后台任务ID
    UIBackgroundTaskIdentifier newTaskId = UIBackgroundTaskInvalid;
    newTaskId = [[UIApplication sharedApplication] beginBackgroundTaskWithExpirationHandler:nil];
    if(newTaskId != UIBackgroundTaskInvalid && backTaskId != UIBackgroundTaskInvalid) {
        [[UIApplication sharedApplication] endBackgroundTask:backTaskId];
    }
    return newTaskId;
}

- (void)configBugly {
    #if !DEBUG
//    BuglyConfig *config = [BuglyConfig new];
//    config.blockMonitorEnable = YES;
//    [Bugly startWithAppId:@"81823fe9a0" config:config];
    #endif
}
@end
