//
//  ChargeUtils.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/6.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface ChargeUtils : NSObject

/// 查询用户在指定游戏中的游戏币数量
/// - Parameters:
///   - userID: 用户ID
///   - appID: APPID
///   - gameID: 游戏ID
///   - completion: callback
+ (void)queryGameCoinWithUserID:(NSString *)userID appID:(long)appID gameID:(nonnull NSString *)gameID completion:(nonnull void (^)(NSInteger errorCode, long gameCoins))completion;

/// 兑换游戏币,gameCoins > 0 则为游戏币兑入， gameCoins < 0 则为游戏币兑出
/// - Parameters:
///   - userID: 用户ID
///   - appID: appID
///   - gameID: 游戏ID
///   - gameCoins: 游戏币数量
///   - completion: callback
+ (void)exchangeGameCoinWithUserID:(NSString *)userID appID:(long)appID gameID:(NSString *)gameID gameCoins:(long)gameCoins completion:(void(^)(NSInteger errorCode, long gameCoins))completion;

/// 获取token
/// - Parameters:
///   - userID: 用户ID
///   - appID: appID
///   - completion: callback
+ (void)getTokenWithUserID:(NSString *)userID appID:(long)appID completion:(nonnull void (^)(NSInteger errorCode, NSString *token))completion;


///  获取弹幕游戏的开播码
/// - Parameters:
///   - appID: appID
///   - gameID: 游戏ID
///   - roomID: 房间ID
///   - userID: 用户ID
///   - userName: 用户昵称
///   - avatar: 用户头像
///   - sex: 用户性别
///   - completion: callback
+ (void)getGameLaunchCode:(long)appID gameID:(NSString *)gameID roomID:(NSString *)roomID userID:(NSString *)userID userName:(NSString *)userName avatar:(NSString *)avatar sex:(int)sex  completion:(void(^)(NSInteger errorCode, NSString * gameLaunchCode))completion;
@end

NS_ASSUME_NONNULL_END
