//
//  ChargeModel.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/6.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface ChargeModel : NSObject

@end

@interface ServerResponse : NSObject

@property (nonatomic, assign) int code;
@property (nonatomic, copy) NSString *message;
@property (nonatomic, copy) NSString *requestID;
@end

@interface QueryGameSpinsRequest : NSObject

@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *userID;
@property (nonatomic, copy) NSString *gameID;

- (void)queryGameSpinsRequest:(NSString *)userID appID:(long)appID gameID:(NSString *)gameID;
- (NSDictionary *)toRequestDictionary;
@end

@interface QueryGameCoinData : NSObject

@property (nonatomic, assign) long gameCoin;
@end

@interface QueryGameSpinsResponse : ServerResponse

@property (nonatomic, strong) QueryGameCoinData *data;
@end


@interface ExchangeGameSpinsRequest : NSObject

@property (nonatomic, copy) NSString *outOrderID;
@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *userID;
@property (nonatomic, copy) NSString *gameID;
@property (nonatomic, assign) long gameSpin;

- (void)exchangeGameSpinsRequest:(NSString *)outOrderID userID:(NSString *)userID appID:(long)appID gameID:(NSString *)gameID gameSpins:(long)gameSpin;
- (NSDictionary *)toRequestDictionary;
@end

@interface ExchangeGameCoinData : NSObject

@property (nonatomic, assign) long gameCoin;
@property (nonatomic, copy) NSString *outOrderID;
@property (nonatomic, copy) NSString *orderID;
@end
 
@interface ExchangeGameSpinsResponse : ServerResponse

@property (nonatomic, strong) ExchangeGameCoinData *data;
@end


@interface GetTokenRequest : NSObject

@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *userID;

- (void)getTokenRequest:(NSString *)userID appID:(long)appID;
- (NSDictionary *)toRequestDictionary;
@end
 

@interface GetOrderInfoRequest : NSObject

@property (nonatomic, copy) NSString *outOrderID;
@property (nonatomic, copy) NSString *orderID;
@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *userID;

- (void)getOrderInfoRequestRequest:(NSString *)outOrderID orderID:(NSString *)orderID appID:(long)appID userID:(NSString *)userID;
- (NSDictionary *)toRequestDictionary;
@end

@interface GetOrderInfoData : NSObject

@property (nonatomic, copy) NSString *outOrderId;
@property (nonatomic, copy) NSString *orderId;
@property (nonatomic, assign) int status;
@property (nonatomic, assign) int createdAt;
@property (nonatomic, assign) int updatedAt;

@end
 
@interface GetOrderInfoResponse : ServerResponse

@property (nonatomic, strong) GetOrderInfoData *data;
@end

//@interface GetUserCurrencyHistoryRequest : NSObject
//
//@property (nonatomic, copy) NSString *userID;
//@property (nonatomic, copy) NSString *gameID;
//@property (nonatomic, assign) long appID;
//@property (nonatomic, copy) NSString *beginTime;
//@property (nonatomic, copy) NSString *endTime;
//@property (nonatomic, assign) int pageLimit;
//@property (nonatomic, assign) int pageIndex;
//
//- (void)getUserCurrencyHistoryRequest:(NSString *)userID gameID:(NSString *)gameID appID:(long)appID beginTime:(NSString *)beginTime endTime:(NSString *)endTime pageLimit:(int)pageLimit pageIndex:(int)pageIndex;
//- (NSDictionary *)toRequestDictionary;
//@end

//@interface GetUserCurrencyHistoryData : NSObject
//
//@property (nonatomic, copy) NSString *userID;
//@property (nonatomic, copy) NSString *gameID;
//@property (nonatomic, copy) NSString *roundID;
//@property (nonatomic, copy) NSString *action;
//@property (nonatomic, assign) int currencyDiff;
//@property (nonatomic, assign) int currency_balance;
//@property (nonatomic, copy) NSString *time;
//@end
//
//@interface GetUserCurrencyHistoryResponse : ServerResponse
//
//@property (nonatomic, assign) int pageLimit;
//@property (nonatomic, assign) int pageIndex;
//@property (nonatomic, assign) int total;
//@property (nonatomic, strong) GetUserCurrencyHistoryData *data;
//@end
//

 
@interface DescribeUserCurrencyRequest : NSObject

@property (nonatomic, copy) NSString *userID;
@property (nonatomic, copy) NSString *miniGameId;


- (void)describeUserCurrencyRequest:(NSString *)userID miniGameId:(NSString *)miniGameId;
- (NSDictionary *)toRequestDictionary;
@end

@interface DescribeUserCurrencyData : NSObject

 
@property (nonatomic, assign) int currencyBalance;
@end
 
@interface DescribeUserCurrencyResponse : ServerResponse

@property (nonatomic, strong) DescribeUserCurrencyData *data;
@end

@interface DescribeGameLaunchCodeRequest : NSObject

@property (nonatomic, assign) long appID;
@property (nonatomic, copy) NSString *roomID;
@property (nonatomic, copy) NSString *miniGameId;
@property (nonatomic, copy) NSString *userID;
@property (nonatomic, copy) NSString *nickName;
@property (nonatomic, copy) NSString *avatar;
@property (nonatomic, assign) int sex;


- (void)describeGameLaunchCode:(long)appID roomID:(NSString *)roomID miniGameId:(NSString *)miniGameId userID:(NSString *)userID nickName:(NSString *)nickName avatar:(NSString *)avatar sex:(int)sex;
- (NSDictionary *)toRequestDictionary;
@end

@interface DescribeGameLaunchCodeData : NSObject

 
@property (nonatomic, copy) NSString *gameLaunchCode;

@end
 
@interface DescribeGameLaunchCodeResponse : ServerResponse

@property (nonatomic, strong) DescribeGameLaunchCodeData *Data;
@end

 
//get_user_currency_history
NS_ASSUME_NONNULL_END
