//
//  ChargeModel.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/6.
//

#import "ChargeModel.h"
#import <NSObject+YYModel.h>

@implementation ChargeModel

@end

@implementation ServerResponse

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"code": @"Code", @"message": @"Message", @"requestID": @"RequestId"};
}
@end

@implementation QueryGameSpinsRequest

- (void)queryGameSpinsRequest:(NSString *)userID appID:(long)appID gameID:(NSString *)gameID {
    self.userID = userID;
    self.appID = appID;
    self.gameID = gameID;
}

- (NSDictionary *)toRequestDictionary {
    return @{
        @"UserId": self.userID,
        @"AppId": @(self.appID),
        @"MiniGameId": self.gameID
    };
}
@end

@implementation QueryGameCoinData

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"gameCoin": @"CurrencyBalance"};
}

@end

@implementation QueryGameSpinsResponse

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"data": @"Data"};
}

@end

@implementation ExchangeGameSpinsRequest

- (void)exchangeGameSpinsRequest:(NSString *)outOrderID userID:(NSString *)userID appID:(long)appID gameID:(NSString *)gameID gameSpins:(long)gameSpin {
    self.outOrderID = outOrderID;
    self.userID = userID;
    self.appID = appID;
    self.gameID = gameID;
    self.gameSpin = gameSpin;
}

- (NSDictionary *)toRequestDictionary {
    NSDictionary *dict = @{
        @"OutOrderId": self.outOrderID,
        @"UserId": self.userID,
        @"MiniGameId": self.gameID,
        @"AppId": @(self.appID),
        @"CurrencyDiff": @(self.gameSpin)
    };
    return dict;
}

@end

@implementation ExchangeGameCoinData

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"gameCoin": @"CurrencyBalance", @"outOrderID": @"OutOrderId", @"orderID": @"OrderId"};
}

@end

@implementation ExchangeGameSpinsResponse

+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"data": @"Data"};
}

@end

@implementation GetTokenRequest

- (void)getTokenRequest:(NSString *)userID appID:(long)appID {
    self.appID = appID;
    self.userID = userID;
}

- (NSDictionary *)toRequestDictionary {
    return @{
        @"app_id": @(self.appID),
        @"user_id": self.userID,
    };
}
@end


@implementation GetOrderInfoRequest

- (void)getOrderInfoRequestRequest:(NSString *)outOrderID orderID:(NSString *)orderID appID:(long)appID userID:(NSString *)userID {
    self.outOrderID = outOrderID;
    self.orderID = orderID;
    self.appID = appID;
    self.userID = userID;
}

- (NSDictionary *)toRequestDictionary {
    return @{
        @"out_order_id": self.outOrderID,
        @"order_id": self.orderID,
        @"app_id": @(self.appID),
        @"user_id": self.userID,
    };
}
@end


@implementation GetOrderInfoData
 
+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"orderId": @"order_id", @"outOrderId": @"out_order_id", @"status": @"status", @"createdAt": @"created_at",  @"updatedAt": @"updated_at"};
}
@end

@implementation GetOrderInfoResponse
 

@end
 
//
//@implementation GetUserCurrencyHistoryRequest
//
//- (void)getUserCurrencyHistoryRequest:(NSString *)userID gameID:(NSString *)gameID appID:(long)appID beginTime:(NSString *)beginTime endTime:(NSString *)endTime pageLimit:(int)pageLimit pageIndex:(int)pageIndex {
//    self.userID = userID;
//    self.gameID = gameID;
//    self.appID = appID;
//    self.beginTime = beginTime;
//    self.endTime = endTime;
//    self.pageLimit = pageLimit;
//    self.pageIndex = pageIndex;
//}
//
//- (NSDictionary *)toRequestDictionary {
//    return @{
//        @"user_id": self.userID,
//        @"app_id": @(self.appID),
//        @"game_id": self.gameID,
//        @"begin_time": self.beginTime,
//        @"end_time": self.endTime,
//        @"page_limit": @(self.pageLimit),
//        @"page_index": @(self.pageIndex),
//    };
//}
//
//@end
//
//
//@implementation GetUserCurrencyHistoryData
//
//+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
//    return @{@"userID": @"user_id", @"gameID": @"out_game_id", @"roundID": @"round_id", @"action": @"action",  @"currencyDiff": @"currency_diff", @"currency_balance": @"currency_balance", @"time": @"time"};
//}
//@end

//@implementation GetUserCurrencyHistoryResponse
//
//+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
//    return @{@"pageLimit": @"page_index", @"pageIndex": @"page_limit", @"total": @"total"};
//}
//@end


@implementation DescribeUserCurrencyRequest

- (void)describeUserCurrencyRequest:(NSString *)userID miniGameId:(NSString *)miniGameId {
    self.userID = userID;
    self.miniGameId = miniGameId;
}

- (NSDictionary *)toRequestDictionary {
    return @{
        @"UserId": self.userID,
        @"MiniGameId": self.miniGameId,
    };
}

@end
 

@implementation DescribeUserCurrencyData
 
+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"currencyBalance": @"CurrencyBalance"};
}
@end

@implementation DescribeUserCurrencyResponse
 
@end


@implementation DescribeGameLaunchCodeRequest

- (void)describeGameLaunchCode:(long)appID roomID:(NSString *)roomID miniGameId:(NSString *)miniGameId userID:(NSString *)userID nickName:(NSString *)nickName avatar:(NSString *)avatar sex:(int)sex {
    self.appID = appID;
    self.roomID = roomID;
    self.miniGameId = miniGameId;
    self.userID = userID;
    self.nickName = nickName;
    self.avatar = avatar;
    self.sex = sex;
}
- (NSDictionary *)toRequestDictionary {
    return @{
        @"RoomId" : self.roomID,
        @"MiniGameId" : self.miniGameId,
        @"AnchorId" : self.userID,
        @"Nickname" : self.nickName,
        @"Avatar" : self.avatar,
        @"Sex" : @(self.sex),
        @"AppId": @(self.appID),
    };
}

@end

@implementation DescribeGameLaunchCodeData
 
+ (NSDictionary<NSString *,id> *)modelCustomPropertyMapper{
    return @{@"gameLaunchCode": @"GameLaunchCode"};
}
@end

@implementation DescribeGameLaunchCodeResponse
 
@end
