//
//  ZegoViewModel.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/8.
//

#import "ZegoGameViewModel.h"
#import "ChargeGameInfo.h"

@implementation ZegoGameViewModel

- (instancetype)init {
    self = [super init];
    if (self) {
        _businessCoin = BUSINESS_COIN_RESET;
//        _roomID = @"7654";
    }
    return self;
}
- (ChargeGameInfo *)getChargeGameInfoWithGameID:(NSString *)gameID {
    for (ChargeGameInfo *chargeGameInfo in self.allGameList) {
        if ([chargeGameInfo.gameInfo.gameID isEqualToString:gameID]) {
            return chargeGameInfo;
        }
    }
    return nil;
}

#pragma mark - getter
- (NSArray *)arrangeData {
    return @[
        @{  @"name": @"简体中文",
            @"language": @(ZegoGameLanguageZHHans),
        },
        @{  @"name": @"英语",
            @"language": @(ZegoGameLanguageEN),
        },
        @{  @"name": @"俄语",
            @"language": @(ZegoGameLanguageRU),
        },
        @{  @"name": @"韩语",
            @"language": @(ZegoGameLanguageKO),
        },
        @{  @"name": @"日语",
            @"language": @(ZegoGameLanguageJA),
        },
        @{  @"name": @"泰语",
            @"language": @(ZegoGameLanguageTH),
        },
        @{  @"name": @"西班牙语",
            @"language": @(ZegoGameLanguageES),
        },
    ];
}
@end
