//
//  ZegoConstants.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/8.
//

#import "ZegoConstants.h"

 
@implementation ZegoConstants

NSString *const STREAM_PREFIX = @"zegotrans_";
NSString *const LIVE_ROOM_PREFIX = @"mini_game_";
NSString *const ROOM_PREFIX_CHAT = @"chat";
NSString *const ROOM_PREFIX_LIVE = @"live";
NSString *const ROOM_PREFIX_GAME = @"gameRoom";

long const BUSINESS_COIN_RESET = 100000;
long const EXCHANGE_COIN_NUMBER = 10000;

+ (NSString *)getErrorMsg:(int)errorCode {
    NSString *key = [NSString stringWithFormat:@"%d", errorCode];
    NSString *errMsg = [ZegoConstants getSparseDict][key];
    if (ZGStringIsEmpty(errMsg)) {
        return [NSString stringWithFormat:@"无此错误信息：%d", errorCode];
    }
    return errMsg;
}

+ (NSDictionary *)getSparseDict {
    NSDictionary *sparseDict = @{
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorTimeOut] : TLLocalizedString(error_timeout),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorAlreadyInit] : TLLocalizedString(error_already_init),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorNotInit] : TLLocalizedString(error_not_init),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorNotSetGameContainer] : TLLocalizedString(error_not_set_container),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorGameInfoIsNull] : TLLocalizedString(error_game_info_is_null),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorGameIsNotRunning] : TLLocalizedString(error_is_not_running_game),
        [NSString stringWithFormat:@"%d", ZegoGameEngineErrorGameNotSupportThisMode] : TLLocalizedString(error_this_game_not_support_this_mode),
    };
    return sparseDict;
}
@end
