//
//  ZGLiveBaseViewController.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/7/20.
//

#import <UIKit/UIKit.h>
#import "ZegoRTCEngineManager.h"
#import "AlignButton.h"
#import "TLArrangePopView.h"


NS_ASSUME_NONNULL_BEGIN
static NSString *ROOM_GAME_INFO = @"game_info";

@interface ZGLiveBaseViewController : UIViewController

@property (nonatomic, strong) ZegoGameViewModel *viewModel;
@property (nonatomic, strong) ZegoRTCEngineManager *rtcManager;
// 当前游戏ID
@property (nonatomic, copy)   NSString *currentGameID;
// 房间人数
@property (nonatomic, strong) AlignButton *memberCountBtn;
// 右上角关闭按钮
@property (nonatomic, strong) UIImageView *closeImageView;
// 加载中label
@property (nonatomic, strong) UILabel *loadingLabel;
// 是否要退出
@property (nonatomic, assign) BOOL isBack;
// 是否正在玩游戏
@property (nonatomic, assign) BOOL isPlayingGame;

// 功能测试相关
@property (nonatomic, strong) UIView *menuZoneView;
@property (nonatomic, strong) UITableView *menuZoneTable;
@property (nonatomic, strong) UIButton *menuZoneBtn;
// 功能菜单中“简体中文” 点击是切换语言列表
@property (nonatomic, strong) TLArrangePopView *arrangeView;
// 测试菜单输入值(游戏宽高)
@property (nonatomic, copy)   NSString *wdStr;

// 初始化数据
- (void)initData;
// 初始化UI
- (void)setupBaseUI;
/**
 * 在游戏开始时把业务金币兑换成游戏金币，保证除了游戏中，其他都是自己在维护业务金币
 */
- (void)onGameStart;
/**
 * 在游戏退出时把游戏金币兑换成业务金币，保证除了游戏中，其他都是自己在维护业务金币
 */
- (void)onGameQuit;

- (void)updateWebviewFrame:(CGFloat)width height:(CGFloat)height;

@end

NS_ASSUME_NONNULL_END
