//
//  ZegoAudioroomViewController.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/5/26.
//

#import <UIKit/UIKit.h>
#import "ZGLiveBaseViewController.h"
#import "RoomGameInfo.h"
#import "ZegoAudioPlayer.h"
#import "ZegoAudioroomMembersView.h"
#import "ZegoSelectPlayerController.h"
#import "ZegoSelectGamePicker.h"


NS_ASSUME_NONNULL_BEGIN

@class ZegoGameViewModel;
@interface ZegoAudioroomViewController : ZGLiveBaseViewController

@property (nonatomic, strong) RoomGameInfo *roomGameInfo;
// 房主点击选择游戏界面上的----开始游戏按钮
@property (nonatomic, strong) UIButton *playGameBtn;
// 关闭游戏按钮
@property (nonatomic, strong) UIButton *closeGameBtn;
@property (nonatomic, strong) UIButton *leaveGameBtn;
// 选择游戏按钮
@property (nonatomic, strong) UIButton *playShowGameBtn;
// 游戏父容器
@property (nonatomic, strong) UIView *gameView;
@property (nonatomic, strong) NSMutableDictionary *gameMap;
// 音效播放器
@property (nonatomic, strong,nullable) ZegoAudioPlayer *audioPlayer;
//成员座位view
@property (nonatomic, strong) ZegoAudioroomMembersView *seatView;
// 游戏信息view
@property (nonatomic, strong) UIImageView *gameIconView;
// 游戏名字view
@property (nonatomic, strong) UILabel *gameNameView;
//开始游戏
@property (nonatomic, strong) UIButton *startGameButton;
//选择游戏数据model
@property (nonatomic, strong) ZegoJoinPlayGameModel *playGameModel;
//顶部view
@property (nonatomic, strong) UIView *topView;
// 当前游戏模式
@property (nonatomic, assign) ZegoGameMode currGameMode;

- (void)joinLiveRoom;

- (void)handleStreamsAdded:(NSArray <StreamInfo *> *)streamInfoList ;

- (void)updateButtonVisibility;

- (void)refreshHostView;

@end

NS_ASSUME_NONNULL_END
