//
//  LanguageTableViewCell.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/3/20.
//

#import "LanguageTableViewCell.h"

@interface LanguageTableViewCell ()

@property (nonatomic, strong) UILabel *titleLabel;
@property (nonatomic, strong) UILabel *languageLabel;
@property (nonatomic, strong) UIButton *iconRightBtn;
@end

@implementation LanguageTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if(self){
        [self createUI];
    }
    return self;
}

- (void)createUI {
    [self.contentView addSubview:self.titleLabel];
    [self.contentView addSubview:self.languageLabel];
    [self.contentView addSubview:self.iconRightBtn];
    
    [self.titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.contentView);
        make.left.equalTo(self.contentView).offset(17);
        make.bottom.equalTo(self.contentView.mas_bottom).offset(-14);
    }];
    
    [self.iconRightBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.titleLabel);
        make.right.equalTo(self.contentView).offset(-10);
        make.width.height.mas_equalTo(20);
    }];
}

- (void)setLanguageModel:(LanguageModel *)model {
    self.titleLabel.text = model.title;
    self.iconRightBtn.selected = model.isSelected;
}

- (UILabel *)titleLabel {
    if(!_titleLabel) {
        _titleLabel = [[UILabel alloc] init];
        _titleLabel.text = @"中文（简体）";
        _titleLabel.textColor = [UIColor whiteColor];
        _titleLabel.font = [UIFont systemFontOfSize:14];
        _titleLabel.textAlignment = NSTextAlignmentLeft;
        [_titleLabel sizeToFit];
    }
    return _titleLabel;
}

- (UIButton *)iconRightBtn {
    if (!_iconRightBtn) {
        _iconRightBtn = [[UIButton alloc] init];
        [_iconRightBtn setImage:[UIImage imageNamed:@"icon_select.png"] forState:UIControlStateSelected];
    }
    return _iconRightBtn;
}

@end


@implementation LanguageModel


@end
