//
//  MatchPlayerView.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/8/8.
//

#import <UIKit/UIKit.h>

typedef NS_ENUM(NSInteger, ZegoGameUserType) {
    // 管理员
    ZegoGameUserTypeAdmin = 1,
    // 可以坐下的人
    ZegoGameUserTypeSittablePersonnel = 2,
    // 观众
    ZegoGameUserTypeAudience = 3,
};

NS_ASSUME_NONNULL_BEGIN

@interface MatchPlayerUserInfo : NSObject

// 用户userID
@property (nonatomic, copy) NSString *userID;

// 用户昵称
@property (nonatomic, copy) NSString *userName;

// 用户头像
@property (nonatomic, copy) NSString *userIcon;

// 是否准备好
@property (nonatomic, assign) BOOL isReady;

// 用户类型
@property (nonatomic, assign) ZegoGameUserType userType;


@end

@interface MatchPlayerSeatView : UIView

- (instancetype)initWithFrame:(CGRect)frame ;

@end


@interface MatchPlayerView : UIView

// 游戏Icon
@property (nonatomic, strong) UIImageView *gameIconView;

// 游戏VS图标
@property (nonatomic, strong) UIImageView *gameVSView;

/// 构造匹配view
/// - Parameters:
///   - frame: frame
///   - userType: 用户类型
///   - maxPlayer: 最大用户数
///   - userList: 占位用户列表
///   - gameIcon: 游戏大图标
- (instancetype)initWithFrame:(CGRect)frame
                     userType:(ZegoGameUserType)userType
                    maxPlayer:(int)maxPlayer
                     userList:(NSArray <MatchPlayerUserInfo *>*)userList
                     gameIcon:(NSString *)gameIcon ;

@end


NS_ASSUME_NONNULL_END
