//
//  MenuTableViewCell.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/1/12.
//

#import "MenuTableViewCell.h"
#import "UITextField+TLTextField.h"

@interface MenuTableViewCell ()<UITextFieldDelegate>

@property(nonatomic, strong) UITextField *valueTextFiedld;
@property(nonatomic, strong) UILabel *nameLabel;
@end

@implementation MenuTableViewCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if(self){
        [self createUI];
    }
    return self;
}

- (void)setMenuDictionary:(NSDictionary *)dict isShow:(BOOL)isShow {
    self.nameLabel.text = dict[@"name"];
    self.valueTextFiedld.hidden = !isShow;
    
    [self.valueTextFiedld mas_updateConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(isShow ? 100 : 0);
    }];
    
    [self.nameLabel mas_updateConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(isShow ? (self.width - 130) : (self.width - 20));
    }];
}

- (void)textFieldChanged:(UITextField *)textField {
    if (self.selectedBlock) {
        self.selectedBlock(textField.text);
    }
}
- (void)textFieldDidEndEditing:(UITextField *)textField {
    if (self.selectedBlock) {
        self.selectedBlock(textField.text);
    }
}

- (void)createUI {
    [self.contentView addSubview:self.valueTextFiedld];
    [self.contentView addSubview:self.nameLabel];
    
    self.layer.cornerRadius = 8.0f;
    self.layer.masksToBounds = YES;
    
    [self.valueTextFiedld mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(5);
        make.left.mas_equalTo(10);
        make.width.mas_equalTo(100);
        make.height.mas_equalTo(40);
    }];
    
    [self.nameLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.valueTextFiedld.mas_centerY);
        make.left.equalTo(self.valueTextFiedld.mas_right).offset(10);
        make.width.mas_equalTo(self.width - 130);
        make.height.mas_equalTo(30);
    }];
}

- (void)setDeValue:(NSString *)deValue {
    self.valueTextFiedld.text = deValue;
}
- (UITextField *)valueTextFiedld {
    if (!_valueTextFiedld) {
        _valueTextFiedld = [UITextField textFieldWithPlaceholder:@""];
        _valueTextFiedld.font = [UIFont systemFontOfSize:14];
        _valueTextFiedld.textColor = [UIColor blackColor];
        _valueTextFiedld.delegate = self;
        [_valueTextFiedld addTarget:self action:@selector(textFieldChanged:) forControlEvents:UIControlEventEditingChanged];
    }
    return _valueTextFiedld;
}


- (UILabel *)nameLabel {
    if(!_nameLabel) {
        _nameLabel = [[UILabel alloc] init];
        _nameLabel.textColor = [UIColor blackColor];
        _nameLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:15];
        _nameLabel.textAlignment = NSTextAlignmentCenter;
        [_nameLabel sizeToFit];
    }
    return _nameLabel;
}

@end
