//
//  TLTestLoginView.m
//  ZegoRoomkitDemo
//
//  Created by KaelDing on 2020/7/15.
//  Copyright © 2020 zego. All rights reserved.
//

#import "MineGameMainView.h"
#import "GameTableViewCell.h"
#import "ChargeGameInfo.h"

@interface MineGameMainView () <UITableViewDelegate, UITableViewDataSource>

@property (nonatomic, strong) UILabel *tipLabel;
@property (nonatomic, strong) UIView *businessView;
@property (nonatomic, strong) UILabel *businessTitleLabel;
@property (nonatomic, strong) UILabel *businessNotesLabel;
@property (nonatomic, strong) UIView *goldCoinsView;
@property (nonatomic, strong) UILabel *goldCoinsLabel;
@property (nonatomic, strong) UIButton *resetButton;

@property (nonatomic, strong) UIView *gameView;
@property (nonatomic, strong) UILabel *gameTitleLabel;
@property (nonatomic, strong) UILabel *gameNotesLabel;
@property (nonatomic, strong) UILabel *gameCoinsTitleLabel;
@property (nonatomic, strong) UILabel *gameCoinsAmountLabel;
@property (nonatomic, strong) UIButton *exchangeButton;
@property (nonatomic, strong) UIButton *withdrawButton;

@property (nonatomic, assign) long initCoins;
@end

@implementation MineGameMainView
 
- (instancetype)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self setupUI];
        [self initData];
    }
    return self;
}

- (void)setupUI {
    [self addSubview:self.tipLabel];
    [self addSubview:self.businessView];
    [self.businessView addSubview:self.businessTitleLabel];
    [self.businessView addSubview:self.businessNotesLabel];
    [self.businessView addSubview:self.goldCoinsView];
    [self.goldCoinsView addSubview:self.goldCoinsLabel];
    [self.goldCoinsView addSubview:self.goldCoinsAmountLabel];
    [self.goldCoinsView addSubview:self.resetButton];
    [self addSubview:self.gameView];
    [self.gameView addSubview:self.gameTitleLabel];
    [self.gameView addSubview:self.gameNotesLabel];
//    [self.gameView addSubview:self.gameCoinsTitleLabel];
//    [self.gameView addSubview:self.gameCoinsAmountLabel];
//    [self.gameView addSubview:self.exchangeButton];
//    [self.gameView addSubview:self.withdrawButton];
    [self.gameView addSubview:self.gameTableView];
    
    
    [self.tipLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self);
        make.left.equalTo(self.mas_left).offset(16);
        make.width.mas_equalTo(kScreenWidth - 32);
        make.height.mas_equalTo(51);
    }];
    
    [self.businessView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.tipLabel.mas_bottom).offset(14);
        make.left.width.equalTo(self.tipLabel);
    }];
    
    [self.businessTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.mas_centerX);
        make.top.mas_equalTo(18);
        make.height.mas_equalTo(22);
    }];
    
    [self.businessNotesLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.businessView).offset(20);
        make.right.equalTo(self.businessView).offset(-20);
        make.top.equalTo(self.businessTitleLabel.mas_bottom).offset(10);
    }];
    
    [self.goldCoinsView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.businessView.mas_centerX);
        make.top.equalTo(self.businessNotesLabel.mas_bottom).offset(20);
        make.height.mas_equalTo(28);
        make.left.right.equalTo(self.businessView);
        make.bottom.equalTo(self.businessView).offset(-18);
    }];
    
    [self.goldCoinsLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.goldCoinsView).offset(20);
        make.top.bottom.equalTo(self.goldCoinsView);
    }];
    
    [self.goldCoinsAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.goldCoinsLabel.mas_right).offset(2);
        make.centerY.equalTo(self.goldCoinsLabel.mas_centerY);
    }];
    
    [self.resetButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.goldCoinsView.mas_right).offset(-20);
        make.centerY.equalTo(self.goldCoinsAmountLabel.mas_centerY);
        make.width.mas_equalTo(78);
        make.height.mas_equalTo(32);
      
    }];
    
    [self.gameView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.businessView.mas_bottom).offset(16);
        make.left.width.equalTo(self.businessView);
        make.bottom.equalTo(self);
    }];
    
    [self.gameTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.gameView.mas_centerX);
        make.top.equalTo(self.gameView).offset(18);
        make.height.mas_equalTo(22);
    }];
    
    [self.gameNotesLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.gameView).offset(20);
        make.right.equalTo(self.gameView).offset(-20);
        make.top.equalTo(self.gameTitleLabel.mas_bottom).offset(10);
    }];
    
//    [self.gameCoinsTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.left.equalTo(self.gameView).offset(20);
//        make.top.equalTo(self.gameNotesLabel.mas_bottom).offset(21);
//        make.bottom.equalTo(self.gameView).offset(-33);;
//    }];
//
//    [self.gameCoinsAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.centerY.equalTo(self.gameCoinsTitleLabel);
//        make.left.equalTo(self.gameCoinsTitleLabel.mas_right).offset(2);
//    }];
//
//    [self.exchangeButton mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.right.equalTo(self.gameView.mas_right).offset(-20);
//        make.centerY.equalTo(self.gameCoinsAmountLabel.mas_centerY);
//        make.width.mas_equalTo(74);
//        make.height.mas_equalTo(28);
//    }];
//
//    [self.withdrawButton mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.right.equalTo(self.exchangeButton.mas_left).offset(-6);
//        make.centerY.equalTo(self.exchangeButton.mas_centerY);
//        make.width.mas_equalTo(74);
//        make.height.mas_equalTo(28);
//    }];
    
    [self.gameTableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.gameView);
        make.top.equalTo(self.gameNotesLabel.mas_bottom).offset(20);
        make.bottom.equalTo(self.gameView.mas_bottom);
    }];
    
}

- (void)initData {
    self.initCoins = self.viewModel.allGameList.count * EXCHANGE_COIN_NUMBER;
    self.gameCoinsAmountLabel.text = [NSString stringWithFormat:@"%lu", self.initCoins];
}

- (void)configureData {
//    self.gameCoinsAmountLabel.text = self.viewModel.gam;
    self.initCoins = self.viewModel.allGameList.count * EXCHANGE_COIN_NUMBER;
    self.gameCoinsAmountLabel.text = [NSString stringWithFormat:@"%lu", self.initCoins];
}

- (void)layoutSubviews {
    
}

#pragma mark - TableViewDelegate & DataSource

- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.viewModel.allGameList.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    GameTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"GameTableViewCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.userInteractionEnabled = YES;
    cell.backgroundColor = [UIColor clearColor];
    
    [cell setMiniGameInfo:self.viewModel.allGameList[indexPath.row]];
    __weak typeof(GameTableViewCell) *weakCell = cell;
    cell.exchangeBlock = ^(ChargeGameInfo * info) {
        if (self.viewModel.businessCoin >= EXCHANGE_COIN_NUMBER) {
            info.gameCoin += EXCHANGE_COIN_NUMBER;
            self.viewModel.businessCoin = self.viewModel.businessCoin - EXCHANGE_COIN_NUMBER;
            self.goldCoinsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessCoin];
            weakCell.gameCoinsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)info.gameCoin];
        } else {
            [MBProgressHUD showSuccess:TLLocalizedString(business_coin_is_not_enough) withFinishBlock:nil];
        }
    };
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 68;
}

#pragma mark - action

- (void)onResetButtonActionButtonClick:(UIButton *)sender {
    self.viewModel.businessCoin = BUSINESS_COIN_RESET;
    self.goldCoinsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessCoin];
}

- (void)onExchangeButtonActionButtonClick:(UIButton *)sender {
    if (self.viewModel.businessCoin >= EXCHANGE_COIN_NUMBER) {
        self.initCoins += EXCHANGE_COIN_NUMBER;
        self.viewModel.businessCoin = self.viewModel.businessCoin - EXCHANGE_COIN_NUMBER;
        self.goldCoinsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.viewModel.businessCoin];
        self.gameCoinsAmountLabel.text = [NSString stringWithFormat:@"%d", (int)self.initCoins];
    } else {
        [MBProgressHUD showSuccess:TLLocalizedString(business_coin_is_not_enough) withFinishBlock:nil];
    }
}

- (void)onWithdrawButtonActionButtonClick:(UIButton *)sender {
    
}

 
#pragma mark - getter
 
- (UILabel *)tipLabel {
    if(!_tipLabel) {
        _tipLabel = [[UILabel alloc] init];
        _tipLabel.text = TLLocalizedString(mall_note1);
        _tipLabel.numberOfLines = 0;
        _tipLabel.textColor = [UIColor colorWithRed:255/255.0 green:91/255.0 blue:91/255.0 alpha:1/1.0];
        _tipLabel.font = [UIFont systemFontOfSize:12];
        _tipLabel.textAlignment = NSTextAlignmentLeft;
        [_tipLabel sizeToFit];
    }
    return _tipLabel;
}

- (UIView *)businessView {
    if (!_businessView) {
        _businessView = [UIView new];
        _businessView.layer.cornerRadius = 20;
        _businessView.layer.masksToBounds = YES;
        _businessView.backgroundColor = [UIColor colorWithHexString:@"#574979"];
    }
    return _businessView;
}

- (UILabel *)businessTitleLabel {
    if (!_businessTitleLabel) {
        _businessTitleLabel = [[UILabel alloc] init];
        _businessTitleLabel.text = TLLocalizedString(business_coin);
        _businessTitleLabel.textColor = [UIColor whiteColor];
        _businessTitleLabel.font = [UIFont systemFontOfSize:16];
        _businessTitleLabel.textAlignment = NSTextAlignmentCenter;
        [_businessTitleLabel sizeToFit];
    }
    return _businessTitleLabel;
}

- (UILabel *)businessNotesLabel {
    if (!_businessNotesLabel) {
        _businessNotesLabel = [[UILabel alloc] init];
        _businessNotesLabel.numberOfLines = 0;
        _businessNotesLabel.text = TLLocalizedString(business_coin_note1);
        _businessNotesLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _businessNotesLabel.font = [UIFont systemFontOfSize:12];
        _businessNotesLabel.textAlignment = NSTextAlignmentLeft;
        [_businessNotesLabel sizeToFit];
    }
    return _businessNotesLabel;
}

- (UIView *)goldCoinsView {
    if (!_goldCoinsView) {
        _goldCoinsView = [UIView new];
    }
    return _goldCoinsView;
}

- (UILabel *)goldCoinsLabel {
    if (!_goldCoinsLabel) {
        _goldCoinsLabel = [[UILabel alloc] init];
        _goldCoinsLabel.text = TLLocalizedString(business_coin_count);
        _goldCoinsLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _goldCoinsLabel.font = BOLD_FONT(12);;
        _goldCoinsLabel.textAlignment = NSTextAlignmentCenter;
        [_goldCoinsLabel sizeToFit];
    }
    return _goldCoinsLabel;
}

- (UILabel *)goldCoinsAmountLabel {
    if (!_goldCoinsAmountLabel) {
        _goldCoinsAmountLabel = [[UILabel alloc] init];
        _goldCoinsAmountLabel.text = @"100000";
        _goldCoinsAmountLabel.textColor = [UIColor whiteColor];
        _goldCoinsAmountLabel.font = BOLD_FONT(15);
        _goldCoinsAmountLabel.textAlignment = NSTextAlignmentCenter;
        [_goldCoinsAmountLabel sizeToFit];
    }
    return _goldCoinsAmountLabel;
}

- (UIButton *)resetButton {
    if (!_resetButton) {
        _resetButton = [UIButton actionButtonWithTitle:TLLocalizedString(reset)];
        _resetButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _resetButton.layer.cornerRadius = 16;
        _resetButton.layer.masksToBounds = YES;
        [_resetButton addTarget:self action:@selector(onResetButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _resetButton;
}

- (UIView *)gameView {
    if (!_gameView) {
        _gameView = [UIView new];
        _gameView.layer.cornerRadius = 20;
        _gameView.layer.masksToBounds = YES;
        _gameView.backgroundColor = [UIColor colorWithHexString:@"#574979"];
    }
    return _gameView;
}

- (UILabel *)gameTitleLabel {
    if (!_gameTitleLabel) {
        _gameTitleLabel = [[UILabel alloc] init];
        _gameTitleLabel.text = TLLocalizedString(game_coin);
        _gameTitleLabel.textColor = [UIColor whiteColor];
        _gameTitleLabel.font = [UIFont systemFontOfSize:16];
        _gameTitleLabel.textAlignment = NSTextAlignmentCenter;
        [_gameTitleLabel sizeToFit];
    }
    return _gameTitleLabel;
}

- (UILabel *)gameNotesLabel {
    if (!_gameNotesLabel) {
        _gameNotesLabel = [[UILabel alloc] init];
        _gameNotesLabel.numberOfLines = 0;
        _gameNotesLabel.text = TLLocalizedString(game_coin_note1);
        _gameNotesLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _gameNotesLabel.font = [UIFont systemFontOfSize:12];
        _gameNotesLabel.textAlignment = NSTextAlignmentLeft;
        [_gameNotesLabel sizeToFit];
    }
    return _gameNotesLabel;
}

- (UILabel *)gameCoinsTitleLabel {
    if (!_gameCoinsTitleLabel) {
        _gameCoinsTitleLabel = [[UILabel alloc] init];
        _gameCoinsTitleLabel.text = [NSString stringWithFormat:@"%@：", TLLocalizedString(game_coin)];
        _gameCoinsTitleLabel.textColor = [UIColor colorWithRGB:0xffffffff alpha:0.7];
        _gameCoinsTitleLabel.font = BOLD_FONT(12);
        _gameCoinsTitleLabel.textAlignment = NSTextAlignmentLeft;
        [_gameCoinsTitleLabel sizeToFit];
    }
    return _gameCoinsTitleLabel;
}

- (UILabel *)gameCoinsAmountLabel {
    if (!_gameCoinsAmountLabel) {
        _gameCoinsAmountLabel = [[UILabel alloc] init];
        _gameCoinsAmountLabel.text = @"10000";
        _gameCoinsAmountLabel.textColor = [UIColor whiteColor];
        _gameCoinsAmountLabel.font = BOLD_FONT(15);
        _gameCoinsAmountLabel.textAlignment = NSTextAlignmentCenter;
        [_gameCoinsAmountLabel sizeToFit];
    }
    return _gameCoinsAmountLabel;
}

- (UITableView *)gameTableView {
    if (!_gameTableView) {
        _gameTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, 0, 0)];
        _gameTableView.delegate = self;
        _gameTableView.dataSource = self;
        [_gameTableView registerClass:[GameTableViewCell class] forCellReuseIdentifier:@"GameTableViewCell"];
        _gameTableView.backgroundColor = [UIColor clearColor];
    }
    return _gameTableView;
}

- (UIButton *)exchangeButton {
    if (!_exchangeButton) {
        _exchangeButton = [UIButton actionButtonWithTitle:TLLocalizedString(deposit)];
        _exchangeButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _exchangeButton.layer.cornerRadius = 14;
        _exchangeButton.layer.masksToBounds = YES;
        [_exchangeButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_exchangeButton addTarget:self action:@selector(onExchangeButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        _exchangeButton.userInteractionEnabled = YES;
    }
    return _exchangeButton;
}

- (UIButton *)withdrawButton {
    if (!_withdrawButton) {
        _withdrawButton = [UIButton actionButtonWithTitle:TLLocalizedString(withdraw)];
        _withdrawButton.titleLabel.font = [UIFont systemFontOfSize:13];
        _withdrawButton.layer.cornerRadius = 14;
        _withdrawButton.layer.masksToBounds = YES;
        _withdrawButton.backgroundColor = [UIColor colorWithRGB:0xffffffff alpha:0.1];
        [_withdrawButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_withdrawButton addTarget:self action:@selector(onWithdrawButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
        _withdrawButton.userInteractionEnabled = YES;
    }
    return _withdrawButton;
}
@end
