//
//  ZegoAudioroomMembersView.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/5/26.
//

#import "ZegoAudioroomMembersView.h"

#define  margin 15
#define  row 4

@interface ZegoAudioroomMembersView ()

@property (nonatomic, assign) CGFloat height;

@end

@implementation ZegoAudioroomMembersView

- (void)setupUI {
    
    CGFloat screen_w = kScreenWidth;
        
    for (int i= 0; i<self.members.count; i++) {
        
        StreamInfo *info = self.members[i];
        
        UILabel *roleL = [[UILabel alloc] init];
        roleL.text = @"房主";
        roleL.textColor = UIColor.whiteColor;
        roleL.layer.cornerRadius = 8;
        roleL.layer.masksToBounds = true;
        roleL.font = [UIFont systemFontOfSize:16.0];
        roleL.hidden = !info.isHost;
        roleL.backgroundColor = UIColor.greenColor;
        [roleL sizeToFit];
        [self addSubview:roleL];
        
        UILabel *label = [[UILabel alloc] init];
        label.text = info.userName;
        label.textColor = UIColor.whiteColor;
        label.font = [UIFont systemFontOfSize:16.0];
        [label sizeToFit];
        [self addSubview:label];
        
        CGFloat w = (screen_w - (row+1)*margin)/row;
        CGFloat h = label.size.height;
        CGFloat x = margin + (i % row) * (w + margin);
        CGFloat y = (i / row) * (h + margin*2) + 5 ;
        CGRect frame = CGRectMake(x, y, w, h);
        roleL.frame = CGRectMake(x, y, roleL.size.width, roleL.size.height);
        
        label.frame = CGRectMake(frame.origin.x , frame.origin.y + 20, frame.size.width, frame.size.height);
        
        self.height = CGRectGetMaxY(label.frame);
    }
}

- (void)setMembers:(NSArray *)members {
    _members = members;
    [self removeAllSubviews];
    [self setupUI];
    
    self.frame = CGRectMake(15, 100, kScreenWidth - 15*2, self.height +15);
}

@end
