//
//  ZGJoinAlterFIeld.m
//  LiveRoom_DataChannel
//
//  Created by zego on 2022/9/22.
//

#import "ZegoPlayGameAlterView.h"
#import "GameCollectionViewCell.h"
#import "UIButton+TLButton.h"
#import "TLRadioButton.h"
#import "ZegoGameViewModel.h"

#define ZGWindow [UIApplication sharedApplication].keyWindow

@implementation JoinPlayGameModel

@end

@interface ZegoPlayGameAlterView () <UICollectionViewDelegate, UICollectionViewDataSource>

@property (nonatomic, strong) UICollectionView *collectionView;

@property(nonatomic, strong) UILabel *titleLabel;
@property(nonatomic, strong) UIButton *joinRoomBtn;

@property (nonatomic, strong) UILabel *gameLabel;
@property (nonatomic, strong) UILabel *betLabel;
@property (nonatomic, strong) UILabel *playerLabel;
@property (nonatomic, strong) UILabel *audioLabel;
@property (nonatomic, strong) UIView *becloudView;

@property (nonatomic, strong) NSMutableArray *radioSpinArray;
@property (nonatomic, strong) NSMutableArray *radioPlayerArray;
@property (nonatomic, strong) NSMutableArray *radioAudioTypeArray;

@property (nonatomic, strong) NSMutableArray *radioSpinButtons;
@property (nonatomic, strong) NSMutableArray *radioPlayerButtons;
@property (nonatomic, strong) NSMutableArray *radioAudioTypeButtons;

@property (nonatomic, assign) NSInteger selectIndex;
@property (nonatomic, assign) NSInteger spin;
@property (nonatomic, assign) int playerNum;
@property (nonatomic, assign) int showModeValue;
@property (nonatomic, assign) int soundCustomPlay;

@property (nonatomic, assign) BOOL isSelected;

@property (nonatomic, copy) PlayGameBlock playGameBlock;

@property (nonatomic, copy) selectedGameBlock selectedGameBlock;
@end

@implementation ZegoPlayGameAlterView

//+ (instancetype)alertView {
//    static ZegoPlayGameAlterView *helper = nil;
//    static dispatch_once_t onceToken;
//    dispatch_once(&onceToken, ^{
//        helper = [[ZegoPlayGameAlterView alloc] init];
//        [helper setupUI];
//    });
//    return helper;
//}

- (instancetype)init {
    self = [super init];
    if (self) {
        _selectIndex = -1;
        [self setupUI];
    }
    return self;
}

- (void)setupUI {
    self.backgroundColor = [UIColor whiteColor];
    [self setCornerRadius:self];
    [self createRadioSpinButtons];
    [self addSubview:self.titleLabel];
    [self addSubview:self.gameLabel];
    [self addSubview:self.playerLabel];
    [self addSubview:self.audioLabel];
    
    [self addSubview:self.collectionView];
    [self addSubview:self.betLabel];
    [self addSubview:self.joinRoomBtn];
}



#pragma mark - 设置控件圆角
- (void)setCornerRadius:(UIView *)view {
    view.layer.cornerRadius = 5.0;
    view.layer.masksToBounds = YES;
}

- (void)show {
    // 蒙版
    UIView *becloudView = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    becloudView.backgroundColor = [UIColor colorWithRGB:0x00000000 alpha:0.3];
    UITapGestureRecognizer *tapGR = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(closeAlertView:)];
    [becloudView addGestureRecognizer:tapGR];

    [ZGWindow addSubview:becloudView];
    self.becloudView = becloudView;
    
    // 输入框
    self.frame = CGRectMake(20 , 0, kScreenWidth - 40, 238 + (kScreenWidth - 80) / 4 + 40);
    self.center = CGPointMake(becloudView.centerX, becloudView.centerY);
    [ZGWindow addSubview:self];
    
//    [self mas_remakeConstraints:^(MASConstraintMaker *make) {
//        make.left.mas_equalTo(20);
//        make.width.mas_equalTo(kScreenWidth - 40);
//        make.centerX.equalTo(becloudView.mas_centerX);
//        make.centerY.equalTo(becloudView.mas_centerY);
//        make.height.mas_equalTo(350);
//    }];
    if (self.isShowGround) {
        self.betLabel.hidden = YES;
        self.playerLabel.hidden = YES;
    } else {
        self.betLabel.hidden = NO;
        self.playerLabel.hidden = NO;
    }
    
    [self.titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(20);
        make.width.mas_equalTo(200);
        make.height.mas_equalTo(18);
        make.centerX.equalTo(self);
    }];
    
    [self.gameLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self).offset(10);
        make.height.mas_equalTo(18);
        make.top.equalTo(self.titleLabel.mas_bottom).offset(10);
        make.width.mas_equalTo(75);
    }];
    
    [self.collectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.gameLabel.mas_bottom).offset(10);
        make.left.equalTo(self);
        make.width.mas_equalTo(kScreenWidth - 40);
        make.height.mas_equalTo((kScreenWidth - 80) / 4 + 40);
    }];
    
    [self.collectionView reloadData];
    
    if (self.isShowGround) {
        [self.radioAudioTypeArray removeAllObjects];
        [self.audioLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.height.equalTo(self.gameLabel);
            make.width.mas_equalTo(200);
            make.height.mas_equalTo(18);
            make.top.equalTo(self.collectionView.mas_bottom).offset(10);
        }];
        int k = 0;
        for (id audioType in @[@(1), @(0)]) {
            RadioModel *audioModel = [[RadioModel alloc] init];
            audioModel.num = [audioType intValue];
            audioModel.tag = [audioType integerValue];
            audioModel.isSelected = [audioType intValue] == 1 ? YES : NO;
            [self.radioAudioTypeArray addObject:audioModel];
            if (k == 0) {
                audioModel.isSelected = YES;
                self.soundCustomPlay = audioModel.tag == 1 ? YES : NO;
            } else {
                audioModel.isSelected = NO;
            }
            k++;
        }
        [self createAudioTypePlayerButtons];
        [self layoutRadioAudioTypeButtons];
    } else {
        [self.betLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.height.equalTo(self.gameLabel);
            make.width.mas_equalTo(200);
            make.height.mas_equalTo(18);
            make.top.equalTo(self.collectionView.mas_bottom).offset(10);
        }];
        
        [self.playerLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.height.equalTo(self.betLabel);
            make.width.mas_equalTo(200);
            make.height.mas_equalTo(18);
            make.top.equalTo(self.betLabel.mas_bottom).offset(10);
        }];
        
        [self.audioLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.height.equalTo(self.playerLabel);
            make.width.mas_equalTo(200);
            make.height.mas_equalTo(18);
            make.top.equalTo(self.playerLabel.mas_bottom).offset(10);
        }];
        [self.joinRoomBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.audioLabel.mas_bottom).offset(10);
            make.centerX.equalTo(self);
            make.width.mas_equalTo(100);
            make.height.mas_equalTo(40);
        }];
        
    }
}

- (void)layoutRadioSpinButtons {
    CGFloat spinWidth = (self.width - 40) / self.radioSpinButtons.count;
    int i = 0;
    for (TLRadioButton *radioSpinButton in self.radioSpinButtons) {
        [radioSpinButton mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.betLabel.mas_bottom);
            make.height.mas_equalTo(48);
            make.width.mas_equalTo(spinWidth);
            make.left.mas_equalTo(i * spinWidth + 20);
        }];
        
        i++;
        if (i == self.radioSpinButtons.count) {
            [self.playerLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.height.equalTo(self.betLabel);
                make.width.mas_equalTo(200);
                make.height.mas_equalTo(18);
                make.top.equalTo(radioSpinButton.mas_bottom).offset(20);
            }];
        }
    }
}

- (void)layoutRadioPlayerButtons {
    CGFloat playerWidth = (self.width - 40) / self.radioPlayerButtons.count;
    int i = 0;
    for (TLRadioButton *radioPlayerButton in self.radioPlayerButtons) {
        [radioPlayerButton mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.playerLabel.mas_bottom);
            make.height.mas_equalTo(48);
            make.width.mas_equalTo(playerWidth);
            make.left.mas_equalTo(i * playerWidth + 20);
        }];
        i++;
        if (i == self.radioPlayerButtons.count) {
            [self.audioLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.left.height.equalTo(self.betLabel);
                make.width.mas_equalTo(200);
                make.height.mas_equalTo(18);
                make.top.equalTo(radioPlayerButton.mas_bottom).offset(20);
            }];
        }
    }
}

- (void)layoutRadioAudioTypeButtons {
    CGFloat audioTypeWidth = (self.width - 40) / self.radioAudioTypeButtons.count;
    int i = 0;
    for (TLRadioButton *radioAudioTypeButton in self.radioAudioTypeButtons) {
        [radioAudioTypeButton mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.equalTo(self.audioLabel.mas_bottom);
            make.height.mas_equalTo(48);
            make.width.mas_equalTo(audioTypeWidth);
            make.left.mas_equalTo(i * audioTypeWidth + 20);
        }];
        i++;
        if (i == self.radioAudioTypeButtons.count) {
            [self.joinRoomBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
                make.top.equalTo(radioAudioTypeButton.mas_bottom).offset(20);
                make.centerX.equalTo(self);
                make.width.mas_equalTo(100);
                make.height.mas_equalTo(40);
            }];
        }
    }
}

- (void)updateGameParams:(ZegoGameInfoDetail *)infoDetail {
    [self.radioSpinArray removeAllObjects];
    int i = 0;
    for (id coin in infoDetail.coin) {
        RadioModel *spinModel = [[RadioModel alloc] init];
        spinModel.num = [coin intValue];
        spinModel.tag = [coin integerValue];
        
        [self.radioSpinArray addObject:spinModel];
        if (i == 0) {
            spinModel.isSelected = YES;
            self.spin = spinModel.tag;
        } else {
            spinModel.isSelected = NO;
        }
        i++;
    }
    
    [self.radioPlayerArray removeAllObjects];
    int j = 0;
    for (id player in infoDetail.playerNum) {
        RadioModel *playerModel = [[RadioModel alloc] init];
        playerModel.num = [player intValue];
        playerModel.tag = [player integerValue];
        playerModel.isSelected = NO;
        [self.radioPlayerArray addObject:playerModel];
        if (j == 0) {
            playerModel.isSelected = YES;
            self.playerNum = (int)playerModel.tag;
        } else {
            playerModel.isSelected = NO;
        }
        j++;
    }
    
    [self.radioAudioTypeArray removeAllObjects];
    int k = 0;
    for (id audioType in @[@(1), @(0)]) {
        RadioModel *audioModel = [[RadioModel alloc] init];
        audioModel.num = [audioType intValue];
        audioModel.tag = [audioType integerValue];
        audioModel.isSelected = [audioType intValue] == 1 ? YES : NO;
        [self.radioAudioTypeArray addObject:audioModel];
        if (k == 0) {
            audioModel.isSelected = YES;
            self.soundCustomPlay = audioModel.tag == 1 ? YES : NO;
        } else {
            audioModel.isSelected = NO;
        }
        k++;
    }
    
    [self createRadioSpinButtons];
    [self layoutRadioSpinButtons];
    [self createRadioPlayerButtons];
    [self layoutRadioPlayerButtons];
    [self createAudioTypePlayerButtons];
    [self layoutRadioAudioTypeButtons];
    
    self.frame = CGRectMake(20 , 0, kScreenWidth - 40, 410 + (kScreenWidth - 80) / 4 + 40);
    self.center = CGPointMake(self.becloudView.centerX, self.becloudView.centerY);
}

#pragma mark - 移除AlertView
- (void)dismiss {
    self.isSelected = NO;
    [self removeFromSuperview];
    [self.becloudView removeFromSuperview];
    self.becloudView = nil;
    [self removeRadioAllviews];
    [self removeAllSubviews];
    [self.radioSpinArray removeAllObjects];
    [self.radioPlayerArray removeAllObjects];
    [self.radioAudioTypeArray removeAllObjects];
    [self.radioSpinButtons removeAllObjects];
    [self.radioPlayerButtons removeAllObjects];
    [self.radioAudioTypeButtons removeAllObjects];
}

- (void)removeRadioAllviews {
    for (TLRadioButton *radioSpinButton in self.radioSpinButtons) {
        [radioSpinButton removeFromSuperview];
    }
    for (TLRadioButton *radioPlayerButton in self.radioPlayerButtons) {
        [radioPlayerButton removeFromSuperview];
    }
    for (TLRadioButton *radioAudioTypeButton in self.radioAudioTypeButtons) {
        [radioAudioTypeButton removeFromSuperview];
    }
    [self.betLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.height.equalTo(self.gameLabel);
        make.width.mas_equalTo(200);
        make.height.mas_equalTo(18);
        make.top.equalTo(self.collectionView.mas_bottom).offset(10);
    }];
    
    [self.playerLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.height.equalTo(self.betLabel);
        make.width.mas_equalTo(200);
        make.height.mas_equalTo(18);
        make.top.equalTo(self.betLabel.mas_bottom).offset(10);
    }];
    
    [self.audioLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.left.height.equalTo(self.playerLabel);
        make.width.mas_equalTo(200);
        make.height.mas_equalTo(18);
        make.top.equalTo(self.playerLabel.mas_bottom).offset(10);
    }];
    
    [self.joinRoomBtn mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.audioLabel.mas_bottom).offset(10);
        make.centerX.equalTo(self);
        make.width.mas_equalTo(100);
        make.height.mas_equalTo(40);
    }];
}

- (void)closeAlertView:(UIGestureRecognizer *)sender {
    [self dismiss];
}

#pragma mark - 接收传过来的block
- (void)playGameBlock:(PlayGameBlock)block {
    self.playGameBlock = block;
}

- (void)selectedGameBlock:(selectedGameBlock)block {
    self.selectedGameBlock = block;
}

- (void)joinRoomActionClick:(UIButton *)sender {
    if (self.selectIndex == -1) {
        [MBProgressHUD showSuccess:[NSString stringWithFormat:TLLocalizedString(please_chose_a_game)] withFinishBlock:nil];
        return;
    }
    
    JoinPlayGameModel *model = [[JoinPlayGameModel alloc] init];
    if (self.isShowGround) {
        model.selectIndex = self.selectIndex;
        model.isSoundCustomPlay = self.soundCustomPlay;

        if (self.playGameBlock) {
            self.playGameBlock(model);
        }
        [self dismiss];
        return;
    }
    if (self.spin == 0) {
//        [MBProgressHUD showSuccess:[NSString stringWithFormat:@"请选择游戏的最小金额数"] withFinishBlock:nil];
//        return;
    }
    
    if (self.playerNum == 0) {
        [MBProgressHUD showSuccess:[NSString stringWithFormat:@"请选择玩家人数"] withFinishBlock:nil];
        return;
    }
    
    model.selectIndex = self.selectIndex;
    model.spin = self.spin;
    model.playerNum = self.playerNum;
    model.isSoundCustomPlay = self.soundCustomPlay;

    if (self.playGameBlock) {
        self.playGameBlock(model);
    }
    [self dismiss];
}

- (void)exitKeyboard {
    [self endEditing:YES];
}

- (void)onRadioSpinButtonClicked:(NSInteger)tag {
    self.spin = tag;
    for (TLRadioButton *spinButton in self.radioSpinButtons) {
        [spinButton setSelected:spinButton.tag == tag];
    }
}

- (void)onRadioPlayerButtonClicked:(NSInteger)tag {
    self.playerNum = (int)tag;
    for (TLRadioButton *playerButton in self.radioPlayerButtons) {
        [playerButton setSelected:playerButton.tag == tag];
    }
}

- (void)onRadioAudioTypeButtonClicked:(NSInteger)tag {
    self.soundCustomPlay = (int)tag;
    for (TLRadioButton *audioTypeButton in self.radioAudioTypeButtons) {
        [audioTypeButton setSelected:audioTypeButton.tag == tag];
    }
}


// 返回每个分区的item个数
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return self.gameList.count;
}

// 返回每个item
- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    GameCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"GameCollectionViewCell" forIndexPath:indexPath];
    cell.userInteractionEnabled = YES;
    cell.backgroundColor = [UIColor whiteColor];
    UIView *selectedBackgroundView = [[UIView alloc] init];
    selectedBackgroundView.backgroundColor = [UIColor greenColor];
    cell.selectedBackgroundView = selectedBackgroundView;
    [cell setMiniGameInfo:self.gameList[indexPath.row]];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    if (!self.isShowGround) {
        [self removeRadioAllviews];
    }
    self.selectIndex = indexPath.row;
    ZegoGameInfo *gameInfo = self.gameList[indexPath.row];
    if (self.selectedGameBlock) {
        self.selectedGameBlock(gameInfo);
    }
}

#pragma mark - getter

- (void)createRadioSpinButtons {
    [self.radioSpinButtons removeAllObjects];
    for (RadioModel *spinModel in self.radioSpinArray) {
        TLRadioButton *button = [UIButton radionButtonWithTitle:[NSString stringWithFormat:@"%d", spinModel.num] isSelected:spinModel.isSelected];
        button.tag = spinModel.tag;
        button.actionBlock = ^(NSInteger tag){
            [self onRadioSpinButtonClicked:tag];
        };
        [self.radioSpinButtons addObject:button];
        [self addSubview:button];
    }
}

- (void)createRadioPlayerButtons {
    [self.radioPlayerButtons removeAllObjects];
    for (RadioModel *playerModel in self.radioPlayerArray) {
        TLRadioButton *button = [UIButton radionButtonWithTitle:[NSString stringWithFormat:@"%d", playerModel.num] isSelected:playerModel.isSelected];
        button.tag = playerModel.tag;
        button.actionBlock = ^(NSInteger tag){
            [self onRadioPlayerButtonClicked:tag];
        };
        [self.radioPlayerButtons addObject:button];
        [self addSubview:button];
    }
}

- (void)createAudioTypePlayerButtons {
    [self.radioAudioTypeButtons removeAllObjects];
    for (RadioModel *audioModel in self.radioAudioTypeArray) {
        TLRadioButton *button = [UIButton radionButtonWithTitle:audioModel.num == 0 ? @"WebView播放": @"Native播放" isSelected:audioModel.isSelected];
        button.tag = audioModel.tag;
        button.actionBlock = ^(NSInteger tag){
            [self onRadioAudioTypeButtonClicked:tag];
        };
        [self.radioAudioTypeButtons addObject:button];
        [self addSubview:button];
    }
}

- (UILabel *)titleLabel {
    if (!_titleLabel) {
        _titleLabel = [[UILabel alloc] init];
        _titleLabel.text = TLLocalizedString(select_game_info);
        _titleLabel.textColor = [UIColor blackColor];
        _titleLabel.font = [UIFont systemFontOfSize:17];
        _titleLabel.textAlignment = NSTextAlignmentCenter;
        [_titleLabel sizeToFit];
    }
    return _titleLabel;
}

- (UILabel *)gameLabel {
    if (!_gameLabel) {
        _gameLabel = [[UILabel alloc] init];
        _gameLabel.textColor = [UIColor colorWithHexString:@"868ca0"];
        _gameLabel.font = MEDIUM_FONT(16);
        _gameLabel.textAlignment = NSTextAlignmentLeft;
        _gameLabel.text =  TLLocalizedString(chose_game);
        [_gameLabel sizeToFit];
    }
    return _gameLabel;
}

#pragma mark - getter

- (UICollectionView *)collectionView {
    if (!_collectionView) {
        UICollectionViewFlowLayout* layout = [[UICollectionViewFlowLayout alloc]init];
        layout.scrollDirection = UICollectionViewScrollDirectionVertical;
        layout.minimumLineSpacing = 10;
        layout.minimumInteritemSpacing = 10;
        layout.sectionInset = UIEdgeInsetsMake(5, 5, 5, 5);
        layout.itemSize = CGSizeMake((kScreenWidth - 80) / 4,  (kScreenWidth - 80) / 4 + 40);
        _collectionView = [[UICollectionView alloc] initWithFrame:self.frame collectionViewLayout:layout];
        _collectionView.backgroundColor = [UIColor whiteColor];
        _collectionView.delegate = self;
        _collectionView.dataSource = self;
        [_collectionView registerClass:[GameCollectionViewCell class] forCellWithReuseIdentifier:@"GameCollectionViewCell"];
    }
    return _collectionView;
}


- (UILabel *)betLabel {
    if (!_betLabel) {
        _betLabel = [[UILabel alloc] init];
        _betLabel.textColor = [UIColor colorWithHexString:@"868ca0"];
        _betLabel.font = MEDIUM_FONT(16);
        _betLabel.textAlignment = NSTextAlignmentLeft;
        _betLabel.text = @"每局赌注金币:";
        [_betLabel sizeToFit];
    }
    return _betLabel;
}

- (UILabel *)playerLabel {
    if (!_playerLabel) {
        _playerLabel = [[UILabel alloc] init];
        _playerLabel.textColor = [UIColor colorWithHexString:@"868ca0"];
        _playerLabel.font = MEDIUM_FONT(16);
        _playerLabel.textAlignment = NSTextAlignmentLeft;
        _playerLabel.text = @"玩家人数:";
        [_playerLabel sizeToFit];
    }
    return _playerLabel;
}
 

- (UILabel *)audioLabel {
    if (!_audioLabel) {
        _audioLabel = [[UILabel alloc] init];
        _audioLabel.textColor = [UIColor colorWithHexString:@"868ca0"];
        _audioLabel.font = MEDIUM_FONT(16);
        _audioLabel.textAlignment = NSTextAlignmentLeft;
        _audioLabel.text = @"声音播放控制:";
        [_audioLabel sizeToFit];
    }
    return _audioLabel;
}

- (UIButton *)joinRoomBtn {
    if (!_joinRoomBtn) {
        _joinRoomBtn = [UIButton actionButtonWithTitle:@"进入游戏"];
        [_joinRoomBtn addTarget:self action:@selector(joinRoomActionClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _joinRoomBtn;
}

- (NSMutableArray *)radioSpinButtons {
    if (!_radioSpinButtons) {
        _radioSpinButtons = [NSMutableArray array];
    }
    return _radioSpinButtons;
}

- (NSMutableArray *)radioPlayerButtons {
    if (!_radioPlayerButtons) {
        _radioPlayerButtons = [NSMutableArray array];
    }
    return _radioPlayerButtons;
}

- (NSMutableArray *)radioSpinArray {
    if (!_radioSpinArray) {
        _radioSpinArray = [NSMutableArray array];
    }
    return _radioSpinArray;
}

- (NSMutableArray *)radioPlayerArray {
    if (!_radioPlayerArray) {
        _radioPlayerArray = [NSMutableArray array];
    }
    return _radioPlayerArray;
}

- (NSMutableArray *)radioAudioTypeArray {
    if (!_radioAudioTypeArray) {
        _radioAudioTypeArray = [NSMutableArray array];
    }
    return _radioAudioTypeArray;
}

- (NSMutableArray *)radioAudioTypeButtons {
    if (!_radioAudioTypeButtons) {
        _radioAudioTypeButtons = [NSMutableArray array];
    }
    return _radioAudioTypeButtons;
}
@end

@implementation RadioModel


@end
