//
//  ZGJoinAlterFIeld.m
//  LiveRoom_DataChannel
//
//  Created by zego on 2022/9/22.
//

#import "ZegoRechargeAlterView.h"
#import "UITextField+TLTextField.h"
#import "UIButton+TLButton.h"

#define ZGWindow [UIApplication sharedApplication].keyWindow

@interface ZegoRechargeAlterView ()

@property(nonatomic, strong) UILabel *titleLabel;

@property(nonatomic, strong) UIButton *rechargeBtn;

@property (nonatomic, strong) UILabel *businessLabel;
@property (nonatomic, strong) UILabel *currentLabel;
@property (nonatomic, strong) UILabel *currentGoldCoinsLabel;
@property (nonatomic, strong) UILabel *exchangeAmountLabel;
@property (nonatomic, strong) UIButton *exchangeButton;

@property (nonatomic, weak) UIView *becloudView;

@property (nonatomic, copy) NSString *gameSpin;

@property (nonatomic, copy) OnRechargeBlock onRechargeBlock;
@end

@implementation ZegoRechargeAlterView

+ (instancetype)alertView {
    static ZegoRechargeAlterView *helper = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        helper = [[ZegoRechargeAlterView alloc] init];
        [helper setupUI];
    });
    return helper;
}
 
- (void)setupUI {
    self.backgroundColor = [UIColor whiteColor];
    [self setCornerRadius:self];
    [self addSubview:self.titleLabel];
    [self addSubview:self.businessLabel];
    [self addSubview:self.goldCoinsAmountLabel];
    [self addSubview:self.currentLabel];
    [self addSubview:self.currentGoldCoinsLabel];
    [self addSubview:self.exchangeAmountLabel];
    [self addSubview:self.exchangeButton];
    [self addSubview:self.rechargeBtn];
     
    // 添加点击手势
//    UITapGestureRecognizer *tapGR = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(exitKeyboard)];
//    [self addGestureRecognizer:tapGR];
}
 

#pragma mark - 设置控件圆角
- (void)setCornerRadius:(UIView *)view {
    view.layer.cornerRadius = 16.0;
    view.layer.masksToBounds = YES;
}

- (void)show {
    [self dismiss];
    // 蒙版
    UIView *becloudView = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    becloudView.backgroundColor = [UIColor blackColor];
    becloudView.layer.opacity = 0.3;
    UITapGestureRecognizer *tapGR = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(closeAlertView:)];
    [becloudView addGestureRecognizer:tapGR];
    
    [ZGWindow addSubview:becloudView];
    self.becloudView = becloudView;
    
    // 输入框
    self.frame = CGRectMake(20 , 0,  [NSBundle isChineseLanguage] ? (kScreenWidth - 104) : (kScreenWidth - 64),  225);
    self.center = CGPointMake(becloudView.centerX, becloudView.centerY);
    [ZGWindow addSubview:self];
    
    [self.titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(22);
        make.width.mas_equalTo(200);
        make.centerX.equalTo(self);
    }];
    
    [self.businessLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self).offset(23);
        make.top.equalTo(self.titleLabel.mas_bottom).offset(12);
//        make.width.mas_equalTo(100);
    }];
    
    [self.goldCoinsAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.currentGoldCoinsLabel.mas_left);
        make.centerY.equalTo(self.businessLabel.mas_centerY);
    }];
    
    [self.currentLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.businessLabel);
        make.top.equalTo(self.businessLabel.mas_bottom).offset(10);
        make.width.height.equalTo(self.businessLabel);
    }];
    
    [self.currentGoldCoinsLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self.currentLabel.mas_right).offset(49);
        make.centerY.equalTo(self.currentLabel.mas_centerY);
    }];
    
    [self.exchangeAmountLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.height.equalTo(self.businessLabel);
        make.top.equalTo(self.currentLabel.mas_bottom).offset(10);
    }];
    
    [self.exchangeButton mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.left.equalTo(self.goldCoinsAmountLabel.mas_left).offset(-10);
        make.right.equalTo(self.mas_right).offset([NSBundle isChineseLanguage] ? -23 : -13);
        make.centerY.equalTo(self.exchangeAmountLabel.mas_centerY);
        make.height.mas_equalTo(28);
        make.width.mas_equalTo(([NSBundle isChineseLanguage] ? 115 : 160));
    }];
    
    [self.rechargeBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.exchangeButton.mas_bottom).offset(24);
        make.centerX.equalTo(self);
        make.width.mas_equalTo(110);
        make.height.mas_equalTo(36);
        make.bottom.equalTo(self.mas_bottom).offset(-22);
    }];
}

#pragma mark - 移除AlertView

- (void)dismiss {
    [self removeFromSuperview];
    [self.becloudView removeFromSuperview];
    self.becloudView = nil;
}

- (void)closeAlertView:(UIButton *)sender {
    [self dismiss];
}

#pragma mark - 接收传过来的block

- (void)onRechargeBlock:(OnRechargeBlock)block {
    self.onRechargeBlock = block;
}

- (void)updateRechargeData:(NSString *)businessCoin gameCoin:(NSString *)gameCoin {
    self.goldCoinsAmountLabel.text = businessCoin;
    self.currentGoldCoinsLabel.text = gameCoin;
    [self.exchangeButton setEnabled:YES];
}

#pragma mark -  action

- (void)onExchangeButtonActionButtonClick:(UIButton *)sender {
    [self.exchangeButton setEnabled:NO];
    if (self.onRechargeBlock) {
        self.onRechargeBlock(self.gameSpin);
    }
}

- (void)onClickRechargeAction:(UIButton *)sender {
    [self dismiss];
}

- (void)exitKeyboard {
    [self endEditing:YES];
}

#pragma mark - getter

- (UILabel *)titleLabel {
    if (!_titleLabel) {
        _titleLabel = [[UILabel alloc] init];
        _titleLabel.text = TLLocalizedString(exchange_coin);
        _titleLabel.textColor = [UIColor blackColor];
        _titleLabel.font = BOLD_FONT(16);
        _titleLabel.textAlignment = NSTextAlignmentCenter;
        [_titleLabel sizeToFit];
    }
    return _titleLabel;
}

- (UILabel *)businessLabel {
    if (!_businessLabel) {
        _businessLabel = [[UILabel alloc] init];
        _businessLabel.textColor = [UIColor blackColor];
        _businessLabel.font = MEDIUM_FONT(14);
        _businessLabel.textAlignment = NSTextAlignmentLeft;
        _businessLabel.text = TLLocalizedString(business_coin);
        [_businessLabel sizeToFit];
    }
    return _businessLabel;
}

- (UILabel *)goldCoinsAmountLabel {
    if (!_goldCoinsAmountLabel) {
        _goldCoinsAmountLabel = [[UILabel alloc] init];
        _goldCoinsAmountLabel.text = @"100000";
        _goldCoinsAmountLabel.textColor = [UIColor blackColor];
        _goldCoinsAmountLabel.font = MEDIUM_FONT(14);
        _goldCoinsAmountLabel.textAlignment = NSTextAlignmentLeft;
        [_goldCoinsAmountLabel sizeToFit];
    }
    return _goldCoinsAmountLabel;
}

- (UILabel *)currentLabel {
    if (!_currentLabel) {
        _currentLabel = [[UILabel alloc] init];
        _currentLabel.textColor = [UIColor blackColor];
        _currentLabel.font = MEDIUM_FONT(14);
        _currentLabel.textAlignment = NSTextAlignmentLeft;
        _currentLabel.text = TLLocalizedString(current_game_coin);
        [_currentLabel sizeToFit];
    }
    return _currentLabel;
}

- (UILabel *)currentGoldCoinsLabel {
    if (!_currentGoldCoinsLabel) {
        _currentGoldCoinsLabel = [[UILabel alloc] init];
        _currentGoldCoinsLabel.textColor = [UIColor blackColor];
        _currentGoldCoinsLabel.font = MEDIUM_FONT(14);
        _currentGoldCoinsLabel.textAlignment = NSTextAlignmentLeft;
        _currentGoldCoinsLabel.text = @"10000";
        [_currentGoldCoinsLabel sizeToFit];
    }
    return _currentGoldCoinsLabel;
}

- (UILabel *)exchangeAmountLabel {
    if (!_exchangeAmountLabel) {
        _exchangeAmountLabel = [[UILabel alloc] init];
        _exchangeAmountLabel.textColor = [UIColor blackColor];
        _exchangeAmountLabel.font = MEDIUM_FONT(14);
        _exchangeAmountLabel.textAlignment = NSTextAlignmentLeft;
        _exchangeAmountLabel.text = TLLocalizedString(exchange_game_coin_count);
        [_exchangeAmountLabel sizeToFit];
    }
    return _exchangeAmountLabel;
}

- (UIButton *)exchangeButton {
    if (!_exchangeButton) {
        _exchangeButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _exchangeButton.layer.cornerRadius = 14;
        _exchangeButton.layer.masksToBounds = YES;
       
        CGColorSpaceRef spaceRef = CGColorSpaceCreateDeviceRGB();
        CGColorRef colorRef = CGColorCreate(spaceRef, (CGFloat[]){109/255.0, 36/255.0, 246/255.0, 1});
     
        // 设置边框的颜色
        _exchangeButton.layer.borderColor = colorRef;
        _exchangeButton.layer.borderWidth = 0.5f;
        _exchangeButton.titleLabel.font = REGULAR_FONT(14);
        [_exchangeButton setTitle:[NSString stringWithFormat: TLLocalizedString(exchange_x_game_coin), 10000] forState:UIControlStateNormal];
        [_exchangeButton setTitleColor:[UIColor colorWithHexString:@"6D24F6"] forState:UIControlStateNormal];
        
        [_exchangeButton addTarget:self action:@selector(onExchangeButtonActionButtonClick:) forControlEvents:UIControlEventTouchUpInside];
      
    }
    return _exchangeButton;
}


- (UIButton *)rechargeBtn {
    if (!_rechargeBtn) {
        _rechargeBtn = [UIButton actionButtonWithTitle:TLLocalizedString(finish)];
        _rechargeBtn.layer.cornerRadius = 18;
        _rechargeBtn.layer.masksToBounds = YES;
        _rechargeBtn.titleLabel.font = REGULAR_FONT(14);
        [_rechargeBtn addTarget:self action:@selector(onClickRechargeAction:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _rechargeBtn;
}
@end
