//
//  ZegoSelectAppIDView.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/7/13.
//

#import "ZegoSelectAppIDView.h"

@implementation ZegoSelectAppIDView

- (instancetype)initWithFrame:(CGRect)frame dataSource:(NSArray *)dataSource {
    self = [super initWithFrame:frame];
    if(self) {
        self.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.5];
        [self setupView:dataSource];
    }
    return self;
}

- (void)setupView:(NSArray *)dataSource {
    UIView *popView = [[UIView alloc] initWithFrame:CGRectMake(kScreenWidth - 160, TOP_BAR_HEIGHT, 140, dataSource.count * 50)];
    popView.clipsToBounds = YES;
    popView.backgroundColor = [UIColor colorWithHexString:@"574979"];
    [self addSubview:popView];
    
    UIView *listView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 160, 50*dataSource.count)];
    listView.layer.cornerRadius = 4;
    listView.clipsToBounds = YES;
    [popView addSubview:listView];
    
    for (int i=0; i<dataSource.count; i++) {
        UIButton *titleButton = [[UIButton alloc] init];
        [titleButton.titleLabel setFont:[UIFont systemFontOfSize:15]];
        [titleButton setTitleColor:UIColor.whiteColor forState:UIControlStateNormal];
        titleButton.titleLabel.textAlignment = NSTextAlignmentCenter;
        [titleButton setTitle:[NSString stringWithFormat:@"%@",dataSource[i]] forState:UIControlStateNormal];
        [listView addSubview:titleButton];
        titleButton.frame = CGRectMake(0, 50*i, popView.width, 50);
        [titleButton addTarget:self action:@selector(buttonAction:) forControlEvents:UIControlEventTouchUpInside];
        
        if(i != dataSource.count -1) {
            UIView *specLine = [[UIView alloc] initWithFrame:CGRectMake(15, titleButton.height-1, titleButton.width - 15*2, 1)];
            specLine.backgroundColor = UIColor.grayColor;
            [titleButton addSubview:specLine];
        }
    }
}
- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event {
    [self removeFromSuperview];
}

- (void)buttonAction:(UIButton *)sender {
    NSString *appID = sender.titleLabel.text;
    [[NSUserDefaults standardUserDefaults] setValue:appID forKey:@"appID"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    UIAlertController *alertVC = [UIAlertController alertControllerWithTitle:nil message:@"切换appID需要退出应用后重新启动" preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        exit(0);
    }];
    [alertVC addAction:cancelAction];
    [ZegoKeyWindow.rootViewController presentViewController:alertVC animated:true completion:nil];
}
@end
