//
//  ZegoSelectGamePicker.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/3/16.
//

#import <UIKit/UIKit.h>

typedef NS_ENUM(NSInteger, ZegoSelectShowType) {
    
    ZegoSelectTypeFullScreen = 1,
    
    ZegoSelectTypeHalfScreen = 2
};

@class ZegoGameViewModel;

NS_ASSUME_NONNULL_BEGIN

@interface ZegoJoinPlayGameModel: NSObject
// 选择游戏列表的索引值
@property (nonatomic, assign) NSInteger selectIndex;
// 每局游戏金币数
@property (nonatomic, assign) NSInteger spin;
// 玩家人数
@property (nonatomic, assign) int playerNum;
// 声音是否有客户自己播放
@property (nonatomic, assign) BOOL isSoundCustomPlay;
// 游戏抽水比列
@property (nonatomic, assign) int pumpingType;
// 游戏抽水类型
@property (nonatomic, assign) int pumpingRatio;

@end

typedef void(^SelectedGameBlock)(ZegoGameInfo *);

// 开始游戏回调
typedef void(^ZegoPlayGameBlock)(ZegoJoinPlayGameModel *);

@interface ZegoSelectGamePicker : UIViewController

/// 显示
+ (instancetype)show:(NSArray <ZegoGameInfo *> *)gameList isShowGround:(BOOL)isShowGround type:(ZegoSelectShowType)type selectedGameBlock:(SelectedGameBlock)selectedGameBlock playGameBlock:(ZegoPlayGameBlock)playGameBlock;

- (void)updateGameParams:(ZegoGameInfoDetail *)infoDetail;

@end

NS_ASSUME_NONNULL_END
