//
//  ZegoSelectMemberView.m
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/6/13.
//

#import "ZegoSelectMemberView.h"

@interface ZegoSelectMemberView ()

@property (nonatomic, copy) NSArray <StreamInfo *>* players;
@property (nonatomic, copy) NSMutableArray *userListButton;
@property (nonatomic, strong) NSMutableArray *selectPlayerList;

@end

@implementation ZegoSelectMemberView

- (instancetype)initWithFrame:(CGRect)frame  {
    self = [super initWithFrame:frame];
    
    if(self) {
        _userListButton = [NSMutableArray array];
        _selectPlayerList = [NSMutableArray array];
    }
    
    return self;
}

- (void)setupUI {
    for (int i = 0; i< self.players.count; i++) {
        StreamInfo *info = self.players[i];
        
        SYButton *btn = [SYButton buttonWithType:UIButtonTypeCustom];
        btn.btnType = LEFT;
        [btn setTitle:info.userName forState:UIControlStateNormal];
        [btn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [btn setImage:[UIImage imageNamed:@"member_selected"] forState:UIControlStateSelected];
        [btn setImage:[UIImage imageNamed:@"member_unselected"] forState:UIControlStateNormal];
        btn.titleLabel.font = [UIFont systemFontOfSize:16.0];
        [btn addTarget:self action:@selector(actionButton:) forControlEvents:UIControlEventTouchUpInside];
        [btn sizeToFit];
        btn.tag = i+1;
        btn.frame = CGRectMake(15.0, 40*i + 10, btn.size.width + 20, 40);
        [self addSubview:btn];
        
        [_userListButton addObject:btn];
    }
}

- (void)updateMembers:(NSArray <StreamInfo *> *) members {
    _players = members;
    [self removeAllSubviews];
    [self setupUI];
}

- (void)actionButton:(UIButton *)sender {
    [sender setSelected:!sender.isSelected];
    id object = self.players[sender.tag -1];
    if(sender.isSelected) {
        [self.selectPlayerList addObject:object];
    } else {
        [self.selectPlayerList removeObject:object];
    }
}

- (NSArray *)getSelectedPlayer {
    return self.selectPlayerList;
}

@end
