//
//  ZegoSelectPlayerController.h
//  ZegoMiniGameEngineDemo
//
//  Created by zego on 2023/6/13.
//

#import <UIKit/UIKit.h>
#import "ZegoRTCEngineManager.h"

NS_ASSUME_NONNULL_BEGIN

@interface ZegoSelectPlayerModel: NSObject

// 玩家人数
@property (nonatomic, assign) int playerNum;
// 选择玩游戏的用户列表
@property (nonatomic, copy) NSArray <StreamInfo *>*selectedPlayers;
// 每局游戏金币数
@property (nonatomic, assign) NSInteger spin;
// 游戏抽水类型
@property (nonatomic, assign) int pumpingType;
// 游戏抽水比列
@property (nonatomic, assign) int pumpingRatio;
// 游戏是否使用机器人
@property (nonatomic, assign) BOOL isUseRobot;

@end

typedef void(^SelectedGameBlock)(ZegoGameInfo *);

// 开始游戏回调
typedef void(^ZegoStartPlayGameBlock)(ZegoSelectPlayerModel *);

@interface ZegoSelectPlayerController : UIViewController

- (instancetype)initShow:(NSArray <StreamInfo *> *)playerList playerNumList:(NSArray *)playerNumList spinList:(NSArray *)spinList playGameBlock:(ZegoStartPlayGameBlock)playGameBlock;

- (void)show;
@end

NS_ASSUME_NONNULL_END
